require 'Qt4'
require 'qrc_visiongui'
require 'ui_cameradialog'
require 'hornetseye'

class CameraDialog < Qt::Dialog

  def initialize( parent = nil )
    super parent
    @ui = Ui::CameraDialog.new
    @ui.setupUi self
    @ui.mode_combo.clear
    @ui.mode_combo.addItem '320x240 YUV (4:2:2) 3.75 fps'
    @ui.mode_combo.addItem '320x240 YUV (4:2:2) 7.5 fps'
    @ui.mode_combo.addItem '320x240 YUV (4:2:2) 15 fps'
    @ui.mode_combo.addItem '320x240 YUV (4:2:2) 30 fps'
    @ui.mode_combo.addItem '640x480 YUV (4:2:2) 3.75 fps'
    @ui.mode_combo.addItem '640x480 YUV (4:2:2) 7.5 fps'
    @ui.mode_combo.addItem '640x480 YUV (4:2:2) 15 fps'
    @ui.mode_combo.addItem '640x480 RGB 24bpp 3.75 fps'
    @ui.mode_combo.addItem '640x480 RGB 24bpp 7.5 fps'
    @ui.mode_combo.addItem '640x480 RGB 24bpp 15 fps'
    @ui.mode_combo.addItem '640x480 Mono 8bpp 3.75 fps'
    @ui.mode_combo.addItem '640x480 Mono 8bpp 7.5 fps'
    @ui.mode_combo.addItem '640x480 Mono 8bpp 15 fps'
    @ui.mode_combo.addItem '640x480 Mono 8bpp 30 fps'
    @ui.mode_combo.currentIndex = 1
  end

  def device
    @ui.device_edit.text
  end

  def node
    @ui.node_spin.value
  end

  def channel
    @ui.channel_spin.value
  end

  def format
    DC1394Input::FORMAT_VGA_NONCOMPRESSED
  end

  def mode
    case @ui.mode_combo.currentIndex
    when 0..3
      DC1394Input::MODE_320x240_YUV422
    when 4..6
      DC1394Input::MODE_640x480_YUV422
    when 7..9
      DC1394Input::MODE_640x480_RGB
    when 10..13
      DC1394Input::MODE_640x480_MONO
    end
  end

  def framerate
    case @ui.mode_combo.currentIndex
    when 0, 4, 7, 10
      DC1394Input::FRAMERATE_3_75
    when 1, 5, 8, 11
      DC1394Input::FRAMERATE_7_5
    when 2, 6, 9, 12
      DC1394Input::FRAMERATE_15
    when 3, 13
      DC1394Input::FRAMERATE_30
    end
  end

  def dt
    case @ui.mode_combo.currentIndex
    when 0, 4, 7, 10
      1.0 / 3.75
      DC1394Input::FRAMERATE_3_75
    when 1, 5, 8, 11
      1.0 / 7.5
    when 2, 6, 9, 12
      1.0 / 15.0
    when 3, 13
      1.0 / 30.0
    end
  end

end
