#!/usr/bin/env ruby
require 'hornetseye'
require 'Qt4'
require 'cameradialog'
require 'visiondialog'
require 'visionwindow'
require 'ui_visionwindow'
require 'visionbase'
include Hornetseye

# * at certain resolution: calibration camera
# * calibration fine-piezo
# * PI-controller closed-loop control
# * point of maximum deflection

# * drift
# * integration of controller (drb)
# * camera-parameters, background subtraction, sensivity correction,
#   supported, resolution, single-capture, Endianess of 16-bit
# * 3-dof reference coordinate system
# * magnification
# * calibration of camera-resolution using a grid,
#   resolution (nm/pixel) and orientation for different magnifications
# * calibration of fine-piezo drive (3D nm/V), wobbling
# ---
# * goniometer
# * wizard for setting up recognition and tracking
# * record videos and capture pictures (optional scale bar, histogram,
#   drawing elements), automatically record indentation experiments,
#   indicate free space
# * home position, range, offset for fine drive
# * calibration of coarse-piezo drive (3D speed)
# * coarse drive bits for 6 directions
# * profiles (user, microscope, holder, camera)
# * multiple firewire cameras
# * libdc1394v2

app = Qt::Application.new ARGV
# puts Qt::StyleFactory.keys.inspect
# ["Windows", "Motif", "CDE", "Plastique", "Cleanlooks"]
# app.setStyle 'Plastique'
win = nil
begin
  win = VisionWindow.new
  win.show
  app.exec
rescue Exception => e
  Qt::MessageBox::critical win, "Error Starting Vision GUI",
    "#{e.message}\n   #{e.backtrace.join("\n   ")}"
end
